/*
 * generated by Xtext 2.27.0
 */
package tdt4250.ra.services;

import com.google.inject.Inject;
import com.google.inject.Singleton;
import java.util.List;
import org.eclipse.xtext.Action;
import org.eclipse.xtext.Alternatives;
import org.eclipse.xtext.Assignment;
import org.eclipse.xtext.CrossReference;
import org.eclipse.xtext.Grammar;
import org.eclipse.xtext.GrammarUtil;
import org.eclipse.xtext.Group;
import org.eclipse.xtext.Keyword;
import org.eclipse.xtext.ParserRule;
import org.eclipse.xtext.RuleCall;
import org.eclipse.xtext.TerminalRule;
import org.eclipse.xtext.UnorderedGroup;
import org.eclipse.xtext.common.services.TerminalsGrammarAccess;
import org.eclipse.xtext.service.AbstractElementFinder;
import org.eclipse.xtext.service.GrammarProvider;

@Singleton
public class RaDSL2022GrammarAccess extends AbstractElementFinder.AbstractGrammarElementFinder {
	
	public class DepartmentElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "tdt4250.ra.RaDSL2022.Department");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Action cDepartmentAction_0 = (Action)cGroup.eContents().get(0);
		private final Keyword cDepartmentKeyword_1 = (Keyword)cGroup.eContents().get(1);
		private final Assignment cNameAssignment_2 = (Assignment)cGroup.eContents().get(2);
		private final RuleCall cNameEStringParserRuleCall_2_0 = (RuleCall)cNameAssignment_2.eContents().get(0);
		private final Keyword cLeftCurlyBracketKeyword_3 = (Keyword)cGroup.eContents().get(3);
		private final Group cGroup_4 = (Group)cGroup.eContents().get(4);
		private final Keyword cShortNameKeyword_4_0 = (Keyword)cGroup_4.eContents().get(0);
		private final Assignment cShortNameAssignment_4_1 = (Assignment)cGroup_4.eContents().get(1);
		private final RuleCall cShortNameEStringParserRuleCall_4_1_0 = (RuleCall)cShortNameAssignment_4_1.eContents().get(0);
		private final Group cGroup_5 = (Group)cGroup.eContents().get(5);
		private final Keyword cStaffKeyword_5_0 = (Keyword)cGroup_5.eContents().get(0);
		private final Keyword cLeftCurlyBracketKeyword_5_1 = (Keyword)cGroup_5.eContents().get(1);
		private final Assignment cStaffAssignment_5_2 = (Assignment)cGroup_5.eContents().get(2);
		private final RuleCall cStaffPersonParserRuleCall_5_2_0 = (RuleCall)cStaffAssignment_5_2.eContents().get(0);
		private final Group cGroup_5_3 = (Group)cGroup_5.eContents().get(3);
		private final Keyword cCommaKeyword_5_3_0 = (Keyword)cGroup_5_3.eContents().get(0);
		private final Assignment cStaffAssignment_5_3_1 = (Assignment)cGroup_5_3.eContents().get(1);
		private final RuleCall cStaffPersonParserRuleCall_5_3_1_0 = (RuleCall)cStaffAssignment_5_3_1.eContents().get(0);
		private final Keyword cRightCurlyBracketKeyword_5_4 = (Keyword)cGroup_5.eContents().get(4);
		private final Group cGroup_6 = (Group)cGroup.eContents().get(6);
		private final Keyword cCoursesKeyword_6_0 = (Keyword)cGroup_6.eContents().get(0);
		private final Keyword cLeftCurlyBracketKeyword_6_1 = (Keyword)cGroup_6.eContents().get(1);
		private final Assignment cCoursesAssignment_6_2 = (Assignment)cGroup_6.eContents().get(2);
		private final RuleCall cCoursesCourseParserRuleCall_6_2_0 = (RuleCall)cCoursesAssignment_6_2.eContents().get(0);
		private final Group cGroup_6_3 = (Group)cGroup_6.eContents().get(3);
		private final Keyword cCommaKeyword_6_3_0 = (Keyword)cGroup_6_3.eContents().get(0);
		private final Assignment cCoursesAssignment_6_3_1 = (Assignment)cGroup_6_3.eContents().get(1);
		private final RuleCall cCoursesCourseParserRuleCall_6_3_1_0 = (RuleCall)cCoursesAssignment_6_3_1.eContents().get(0);
		private final Keyword cRightCurlyBracketKeyword_6_4 = (Keyword)cGroup_6.eContents().get(4);
		private final Group cGroup_7 = (Group)cGroup.eContents().get(7);
		private final Keyword cResourceAllocationsKeyword_7_0 = (Keyword)cGroup_7.eContents().get(0);
		private final Keyword cLeftCurlyBracketKeyword_7_1 = (Keyword)cGroup_7.eContents().get(1);
		private final Assignment cResourceAllocationsAssignment_7_2 = (Assignment)cGroup_7.eContents().get(2);
		private final RuleCall cResourceAllocationsResourceAllocationParserRuleCall_7_2_0 = (RuleCall)cResourceAllocationsAssignment_7_2.eContents().get(0);
		private final Group cGroup_7_3 = (Group)cGroup_7.eContents().get(3);
		private final Keyword cCommaKeyword_7_3_0 = (Keyword)cGroup_7_3.eContents().get(0);
		private final Assignment cResourceAllocationsAssignment_7_3_1 = (Assignment)cGroup_7_3.eContents().get(1);
		private final RuleCall cResourceAllocationsResourceAllocationParserRuleCall_7_3_1_0 = (RuleCall)cResourceAllocationsAssignment_7_3_1.eContents().get(0);
		private final Keyword cRightCurlyBracketKeyword_7_4 = (Keyword)cGroup_7.eContents().get(4);
		private final Keyword cRightCurlyBracketKeyword_8 = (Keyword)cGroup.eContents().get(8);
		
		//Department returns Department:
		//    {Department}
		//    'Department'
		//    name=EString
		//    '{'
		//        ('shortName' shortName=EString)?
		//        ('staff' '{' staff+=Person ( "," staff+=Person)* '}' )?
		//        ('courses' '{' courses+=Course ( "," courses+=Course)* '}' )?
		//        ('resourceAllocations' '{' resourceAllocations+=ResourceAllocation ( "," resourceAllocations+=ResourceAllocation)* '}' )?
		//    '}';
		@Override public ParserRule getRule() { return rule; }
		
		//{Department}
		//'Department'
		//name=EString
		//'{'
		//    ('shortName' shortName=EString)?
		//    ('staff' '{' staff+=Person ( "," staff+=Person)* '}' )?
		//    ('courses' '{' courses+=Course ( "," courses+=Course)* '}' )?
		//    ('resourceAllocations' '{' resourceAllocations+=ResourceAllocation ( "," resourceAllocations+=ResourceAllocation)* '}' )?
		//'}'
		public Group getGroup() { return cGroup; }
		
		//{Department}
		public Action getDepartmentAction_0() { return cDepartmentAction_0; }
		
		//'Department'
		public Keyword getDepartmentKeyword_1() { return cDepartmentKeyword_1; }
		
		//name=EString
		public Assignment getNameAssignment_2() { return cNameAssignment_2; }
		
		//EString
		public RuleCall getNameEStringParserRuleCall_2_0() { return cNameEStringParserRuleCall_2_0; }
		
		//'{'
		public Keyword getLeftCurlyBracketKeyword_3() { return cLeftCurlyBracketKeyword_3; }
		
		//('shortName' shortName=EString)?
		public Group getGroup_4() { return cGroup_4; }
		
		//'shortName'
		public Keyword getShortNameKeyword_4_0() { return cShortNameKeyword_4_0; }
		
		//shortName=EString
		public Assignment getShortNameAssignment_4_1() { return cShortNameAssignment_4_1; }
		
		//EString
		public RuleCall getShortNameEStringParserRuleCall_4_1_0() { return cShortNameEStringParserRuleCall_4_1_0; }
		
		//('staff' '{' staff+=Person ( "," staff+=Person)* '}' )?
		public Group getGroup_5() { return cGroup_5; }
		
		//'staff'
		public Keyword getStaffKeyword_5_0() { return cStaffKeyword_5_0; }
		
		//'{'
		public Keyword getLeftCurlyBracketKeyword_5_1() { return cLeftCurlyBracketKeyword_5_1; }
		
		//staff+=Person
		public Assignment getStaffAssignment_5_2() { return cStaffAssignment_5_2; }
		
		//Person
		public RuleCall getStaffPersonParserRuleCall_5_2_0() { return cStaffPersonParserRuleCall_5_2_0; }
		
		//( "," staff+=Person)*
		public Group getGroup_5_3() { return cGroup_5_3; }
		
		//","
		public Keyword getCommaKeyword_5_3_0() { return cCommaKeyword_5_3_0; }
		
		//staff+=Person
		public Assignment getStaffAssignment_5_3_1() { return cStaffAssignment_5_3_1; }
		
		//Person
		public RuleCall getStaffPersonParserRuleCall_5_3_1_0() { return cStaffPersonParserRuleCall_5_3_1_0; }
		
		//'}'
		public Keyword getRightCurlyBracketKeyword_5_4() { return cRightCurlyBracketKeyword_5_4; }
		
		//('courses' '{' courses+=Course ( "," courses+=Course)* '}' )?
		public Group getGroup_6() { return cGroup_6; }
		
		//'courses'
		public Keyword getCoursesKeyword_6_0() { return cCoursesKeyword_6_0; }
		
		//'{'
		public Keyword getLeftCurlyBracketKeyword_6_1() { return cLeftCurlyBracketKeyword_6_1; }
		
		//courses+=Course
		public Assignment getCoursesAssignment_6_2() { return cCoursesAssignment_6_2; }
		
		//Course
		public RuleCall getCoursesCourseParserRuleCall_6_2_0() { return cCoursesCourseParserRuleCall_6_2_0; }
		
		//( "," courses+=Course)*
		public Group getGroup_6_3() { return cGroup_6_3; }
		
		//","
		public Keyword getCommaKeyword_6_3_0() { return cCommaKeyword_6_3_0; }
		
		//courses+=Course
		public Assignment getCoursesAssignment_6_3_1() { return cCoursesAssignment_6_3_1; }
		
		//Course
		public RuleCall getCoursesCourseParserRuleCall_6_3_1_0() { return cCoursesCourseParserRuleCall_6_3_1_0; }
		
		//'}'
		public Keyword getRightCurlyBracketKeyword_6_4() { return cRightCurlyBracketKeyword_6_4; }
		
		//('resourceAllocations' '{' resourceAllocations+=ResourceAllocation ( "," resourceAllocations+=ResourceAllocation)* '}' )?
		public Group getGroup_7() { return cGroup_7; }
		
		//'resourceAllocations'
		public Keyword getResourceAllocationsKeyword_7_0() { return cResourceAllocationsKeyword_7_0; }
		
		//'{'
		public Keyword getLeftCurlyBracketKeyword_7_1() { return cLeftCurlyBracketKeyword_7_1; }
		
		//resourceAllocations+=ResourceAllocation
		public Assignment getResourceAllocationsAssignment_7_2() { return cResourceAllocationsAssignment_7_2; }
		
		//ResourceAllocation
		public RuleCall getResourceAllocationsResourceAllocationParserRuleCall_7_2_0() { return cResourceAllocationsResourceAllocationParserRuleCall_7_2_0; }
		
		//( "," resourceAllocations+=ResourceAllocation)*
		public Group getGroup_7_3() { return cGroup_7_3; }
		
		//","
		public Keyword getCommaKeyword_7_3_0() { return cCommaKeyword_7_3_0; }
		
		//resourceAllocations+=ResourceAllocation
		public Assignment getResourceAllocationsAssignment_7_3_1() { return cResourceAllocationsAssignment_7_3_1; }
		
		//ResourceAllocation
		public RuleCall getResourceAllocationsResourceAllocationParserRuleCall_7_3_1_0() { return cResourceAllocationsResourceAllocationParserRuleCall_7_3_1_0; }
		
		//'}'
		public Keyword getRightCurlyBracketKeyword_7_4() { return cRightCurlyBracketKeyword_7_4; }
		
		//'}'
		public Keyword getRightCurlyBracketKeyword_8() { return cRightCurlyBracketKeyword_8; }
	}
	public class EStringElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "tdt4250.ra.RaDSL2022.EString");
		private final Alternatives cAlternatives = (Alternatives)rule.eContents().get(1);
		private final RuleCall cSTRINGTerminalRuleCall_0 = (RuleCall)cAlternatives.eContents().get(0);
		private final RuleCall cIDTerminalRuleCall_1 = (RuleCall)cAlternatives.eContents().get(1);
		
		//EString returns ecore::EString:
		//    STRING | ID;
		@Override public ParserRule getRule() { return rule; }
		
		//STRING | ID
		public Alternatives getAlternatives() { return cAlternatives; }
		
		//STRING
		public RuleCall getSTRINGTerminalRuleCall_0() { return cSTRINGTerminalRuleCall_0; }
		
		//ID
		public RuleCall getIDTerminalRuleCall_1() { return cIDTerminalRuleCall_1; }
	}
	public class PersonElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "tdt4250.ra.RaDSL2022.Person");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Action cPersonAction_0 = (Action)cGroup.eContents().get(0);
		private final Keyword cPersonKeyword_1 = (Keyword)cGroup.eContents().get(1);
		private final Assignment cNameAssignment_2 = (Assignment)cGroup.eContents().get(2);
		private final RuleCall cNameEStringParserRuleCall_2_0 = (RuleCall)cNameAssignment_2.eContents().get(0);
		
		//Person returns Person:
		//    {Person}
		//    'Person'
		//    name=EString
		////    '{'
		////        ('allocations' '(' allocations+=[ResourceAllocation|EString] ( "," allocations+=[ResourceAllocation|EString])* ')' )?
		////    '}'
		//;
		@Override public ParserRule getRule() { return rule; }
		
		//{Person}
		//'Person'
		//name=EString
		public Group getGroup() { return cGroup; }
		
		//{Person}
		public Action getPersonAction_0() { return cPersonAction_0; }
		
		//'Person'
		public Keyword getPersonKeyword_1() { return cPersonKeyword_1; }
		
		//name=EString
		public Assignment getNameAssignment_2() { return cNameAssignment_2; }
		
		//EString
		public RuleCall getNameEStringParserRuleCall_2_0() { return cNameEStringParserRuleCall_2_0; }
	}
	public class CourseElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "tdt4250.ra.RaDSL2022.Course");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Action cCourseAction_0 = (Action)cGroup.eContents().get(0);
		private final Keyword cCourseKeyword_1 = (Keyword)cGroup.eContents().get(1);
		private final Assignment cNameAssignment_2 = (Assignment)cGroup.eContents().get(2);
		private final RuleCall cNameEStringParserRuleCall_2_0 = (RuleCall)cNameAssignment_2.eContents().get(0);
		private final Keyword cLeftCurlyBracketKeyword_3 = (Keyword)cGroup.eContents().get(3);
		private final UnorderedGroup cUnorderedGroup_4 = (UnorderedGroup)cGroup.eContents().get(4);
		private final Group cGroup_4_0 = (Group)cUnorderedGroup_4.eContents().get(0);
		private final Keyword cCodeKeyword_4_0_0 = (Keyword)cGroup_4_0.eContents().get(0);
		private final Assignment cCodeAssignment_4_0_1 = (Assignment)cGroup_4_0.eContents().get(1);
		private final RuleCall cCodeEStringParserRuleCall_4_0_1_0 = (RuleCall)cCodeAssignment_4_0_1.eContents().get(0);
		private final Group cGroup_4_1 = (Group)cUnorderedGroup_4.eContents().get(1);
		private final Keyword cRolesKeyword_4_1_0 = (Keyword)cGroup_4_1.eContents().get(0);
		private final Keyword cLeftCurlyBracketKeyword_4_1_1 = (Keyword)cGroup_4_1.eContents().get(1);
		private final Assignment cRolesAssignment_4_1_2 = (Assignment)cGroup_4_1.eContents().get(2);
		private final RuleCall cRolesRoleParserRuleCall_4_1_2_0 = (RuleCall)cRolesAssignment_4_1_2.eContents().get(0);
		private final Group cGroup_4_1_3 = (Group)cGroup_4_1.eContents().get(3);
		private final Keyword cCommaKeyword_4_1_3_0 = (Keyword)cGroup_4_1_3.eContents().get(0);
		private final Assignment cRolesAssignment_4_1_3_1 = (Assignment)cGroup_4_1_3.eContents().get(1);
		private final RuleCall cRolesRoleParserRuleCall_4_1_3_1_0 = (RuleCall)cRolesAssignment_4_1_3_1.eContents().get(0);
		private final Keyword cRightCurlyBracketKeyword_4_1_4 = (Keyword)cGroup_4_1.eContents().get(4);
		private final Keyword cRightCurlyBracketKeyword_5 = (Keyword)cGroup.eContents().get(5);
		
		//Course returns Course:
		//    {Course}
		//    'Course'
		//    name=EString
		//    '{'
		//        (
		//            ('code' code=EString)?
		//                &
		//              ('roles' '{' roles+=Role ( "," roles+=Role)* '}' )?
		//        )
		//    '}';
		@Override public ParserRule getRule() { return rule; }
		
		//{Course}
		//'Course'
		//name=EString
		//'{'
		//    (
		//        ('code' code=EString)?
		//            &
		//          ('roles' '{' roles+=Role ( "," roles+=Role)* '}' )?
		//    )
		//'}'
		public Group getGroup() { return cGroup; }
		
		//{Course}
		public Action getCourseAction_0() { return cCourseAction_0; }
		
		//'Course'
		public Keyword getCourseKeyword_1() { return cCourseKeyword_1; }
		
		//name=EString
		public Assignment getNameAssignment_2() { return cNameAssignment_2; }
		
		//EString
		public RuleCall getNameEStringParserRuleCall_2_0() { return cNameEStringParserRuleCall_2_0; }
		
		//'{'
		public Keyword getLeftCurlyBracketKeyword_3() { return cLeftCurlyBracketKeyword_3; }
		
		//(
		//    ('code' code=EString)?
		//        &
		//      ('roles' '{' roles+=Role ( "," roles+=Role)* '}' )?
		//)
		public UnorderedGroup getUnorderedGroup_4() { return cUnorderedGroup_4; }
		
		//('code' code=EString)?
		public Group getGroup_4_0() { return cGroup_4_0; }
		
		//'code'
		public Keyword getCodeKeyword_4_0_0() { return cCodeKeyword_4_0_0; }
		
		//code=EString
		public Assignment getCodeAssignment_4_0_1() { return cCodeAssignment_4_0_1; }
		
		//EString
		public RuleCall getCodeEStringParserRuleCall_4_0_1_0() { return cCodeEStringParserRuleCall_4_0_1_0; }
		
		//('roles' '{' roles+=Role ( "," roles+=Role)* '}' )?
		public Group getGroup_4_1() { return cGroup_4_1; }
		
		//'roles'
		public Keyword getRolesKeyword_4_1_0() { return cRolesKeyword_4_1_0; }
		
		//'{'
		public Keyword getLeftCurlyBracketKeyword_4_1_1() { return cLeftCurlyBracketKeyword_4_1_1; }
		
		//roles+=Role
		public Assignment getRolesAssignment_4_1_2() { return cRolesAssignment_4_1_2; }
		
		//Role
		public RuleCall getRolesRoleParserRuleCall_4_1_2_0() { return cRolesRoleParserRuleCall_4_1_2_0; }
		
		//( "," roles+=Role)*
		public Group getGroup_4_1_3() { return cGroup_4_1_3; }
		
		//","
		public Keyword getCommaKeyword_4_1_3_0() { return cCommaKeyword_4_1_3_0; }
		
		//roles+=Role
		public Assignment getRolesAssignment_4_1_3_1() { return cRolesAssignment_4_1_3_1; }
		
		//Role
		public RuleCall getRolesRoleParserRuleCall_4_1_3_1_0() { return cRolesRoleParserRuleCall_4_1_3_1_0; }
		
		//'}'
		public Keyword getRightCurlyBracketKeyword_4_1_4() { return cRightCurlyBracketKeyword_4_1_4; }
		
		//'}'
		public Keyword getRightCurlyBracketKeyword_5() { return cRightCurlyBracketKeyword_5; }
	}
	public class ResourceAllocationElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "tdt4250.ra.RaDSL2022.ResourceAllocation");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Action cResourceAllocationAction_0 = (Action)cGroup.eContents().get(0);
		private final Keyword cResourceAllocationKeyword_1 = (Keyword)cGroup.eContents().get(1);
		private final Keyword cLeftCurlyBracketKeyword_2 = (Keyword)cGroup.eContents().get(2);
		private final Group cGroup_3 = (Group)cGroup.eContents().get(3);
		private final Keyword cFactorKeyword_3_0 = (Keyword)cGroup_3.eContents().get(0);
		private final Assignment cFactorAssignment_3_1 = (Assignment)cGroup_3.eContents().get(1);
		private final RuleCall cFactorEFloatParserRuleCall_3_1_0 = (RuleCall)cFactorAssignment_3_1.eContents().get(0);
		private final Group cGroup_4 = (Group)cGroup.eContents().get(4);
		private final Keyword cPersonKeyword_4_0 = (Keyword)cGroup_4.eContents().get(0);
		private final Assignment cPersonAssignment_4_1 = (Assignment)cGroup_4.eContents().get(1);
		private final CrossReference cPersonPersonCrossReference_4_1_0 = (CrossReference)cPersonAssignment_4_1.eContents().get(0);
		private final RuleCall cPersonPersonEStringParserRuleCall_4_1_0_1 = (RuleCall)cPersonPersonCrossReference_4_1_0.eContents().get(1);
		private final Group cGroup_5 = (Group)cGroup.eContents().get(5);
		private final Keyword cCourseKeyword_5_0 = (Keyword)cGroup_5.eContents().get(0);
		private final Assignment cCourseAssignment_5_1 = (Assignment)cGroup_5.eContents().get(1);
		private final CrossReference cCourseCourseCrossReference_5_1_0 = (CrossReference)cCourseAssignment_5_1.eContents().get(0);
		private final RuleCall cCourseCourseEStringParserRuleCall_5_1_0_1 = (RuleCall)cCourseCourseCrossReference_5_1_0.eContents().get(1);
		private final Group cGroup_6 = (Group)cGroup.eContents().get(6);
		private final Keyword cRoleKeyword_6_0 = (Keyword)cGroup_6.eContents().get(0);
		private final Assignment cRoleAssignment_6_1 = (Assignment)cGroup_6.eContents().get(1);
		private final CrossReference cRoleRoleCrossReference_6_1_0 = (CrossReference)cRoleAssignment_6_1.eContents().get(0);
		private final RuleCall cRoleRoleEStringParserRuleCall_6_1_0_1 = (RuleCall)cRoleRoleCrossReference_6_1_0.eContents().get(1);
		private final Keyword cRightCurlyBracketKeyword_7 = (Keyword)cGroup.eContents().get(7);
		
		//ResourceAllocation returns ResourceAllocation:
		//    {ResourceAllocation}
		//    'ResourceAllocation'
		//    '{'
		//        ('factor' factor=EFloat)?
		//        ('person' person=[Person|EString])?
		//        ('course' course=[Course|EString])?
		//        ('role' role=[Role|EString])?
		//    '}';
		@Override public ParserRule getRule() { return rule; }
		
		//{ResourceAllocation}
		//'ResourceAllocation'
		//'{'
		//    ('factor' factor=EFloat)?
		//    ('person' person=[Person|EString])?
		//    ('course' course=[Course|EString])?
		//    ('role' role=[Role|EString])?
		//'}'
		public Group getGroup() { return cGroup; }
		
		//{ResourceAllocation}
		public Action getResourceAllocationAction_0() { return cResourceAllocationAction_0; }
		
		//'ResourceAllocation'
		public Keyword getResourceAllocationKeyword_1() { return cResourceAllocationKeyword_1; }
		
		//'{'
		public Keyword getLeftCurlyBracketKeyword_2() { return cLeftCurlyBracketKeyword_2; }
		
		//('factor' factor=EFloat)?
		public Group getGroup_3() { return cGroup_3; }
		
		//'factor'
		public Keyword getFactorKeyword_3_0() { return cFactorKeyword_3_0; }
		
		//factor=EFloat
		public Assignment getFactorAssignment_3_1() { return cFactorAssignment_3_1; }
		
		//EFloat
		public RuleCall getFactorEFloatParserRuleCall_3_1_0() { return cFactorEFloatParserRuleCall_3_1_0; }
		
		//('person' person=[Person|EString])?
		public Group getGroup_4() { return cGroup_4; }
		
		//'person'
		public Keyword getPersonKeyword_4_0() { return cPersonKeyword_4_0; }
		
		//person=[Person|EString]
		public Assignment getPersonAssignment_4_1() { return cPersonAssignment_4_1; }
		
		//[Person|EString]
		public CrossReference getPersonPersonCrossReference_4_1_0() { return cPersonPersonCrossReference_4_1_0; }
		
		//EString
		public RuleCall getPersonPersonEStringParserRuleCall_4_1_0_1() { return cPersonPersonEStringParserRuleCall_4_1_0_1; }
		
		//('course' course=[Course|EString])?
		public Group getGroup_5() { return cGroup_5; }
		
		//'course'
		public Keyword getCourseKeyword_5_0() { return cCourseKeyword_5_0; }
		
		//course=[Course|EString]
		public Assignment getCourseAssignment_5_1() { return cCourseAssignment_5_1; }
		
		//[Course|EString]
		public CrossReference getCourseCourseCrossReference_5_1_0() { return cCourseCourseCrossReference_5_1_0; }
		
		//EString
		public RuleCall getCourseCourseEStringParserRuleCall_5_1_0_1() { return cCourseCourseEStringParserRuleCall_5_1_0_1; }
		
		//('role' role=[Role|EString])?
		public Group getGroup_6() { return cGroup_6; }
		
		//'role'
		public Keyword getRoleKeyword_6_0() { return cRoleKeyword_6_0; }
		
		//role=[Role|EString]
		public Assignment getRoleAssignment_6_1() { return cRoleAssignment_6_1; }
		
		//[Role|EString]
		public CrossReference getRoleRoleCrossReference_6_1_0() { return cRoleRoleCrossReference_6_1_0; }
		
		//EString
		public RuleCall getRoleRoleEStringParserRuleCall_6_1_0_1() { return cRoleRoleEStringParserRuleCall_6_1_0_1; }
		
		//'}'
		public Keyword getRightCurlyBracketKeyword_7() { return cRightCurlyBracketKeyword_7; }
	}
	public class RoleElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "tdt4250.ra.RaDSL2022.Role");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Action cRoleAction_0 = (Action)cGroup.eContents().get(0);
		private final Keyword cRoleKeyword_1 = (Keyword)cGroup.eContents().get(1);
		private final Assignment cNameAssignment_2 = (Assignment)cGroup.eContents().get(2);
		private final RuleCall cNameEStringParserRuleCall_2_0 = (RuleCall)cNameAssignment_2.eContents().get(0);
		private final Keyword cLeftCurlyBracketKeyword_3 = (Keyword)cGroup.eContents().get(3);
		private final Group cGroup_4 = (Group)cGroup.eContents().get(4);
		private final Keyword cWorkloadKeyword_4_0 = (Keyword)cGroup_4.eContents().get(0);
		private final Assignment cWorkloadAssignment_4_1 = (Assignment)cGroup_4.eContents().get(1);
		private final RuleCall cWorkloadEFloatParserRuleCall_4_1_0 = (RuleCall)cWorkloadAssignment_4_1.eContents().get(0);
		private final Keyword cRightCurlyBracketKeyword_5 = (Keyword)cGroup.eContents().get(5);
		
		//Role returns Role:
		//    {Role}
		//    'Role'
		//    name=EString
		//    '{'
		//        ('workload' workload=EFloat)?
		//    '}';
		@Override public ParserRule getRule() { return rule; }
		
		//{Role}
		//'Role'
		//name=EString
		//'{'
		//    ('workload' workload=EFloat)?
		//'}'
		public Group getGroup() { return cGroup; }
		
		//{Role}
		public Action getRoleAction_0() { return cRoleAction_0; }
		
		//'Role'
		public Keyword getRoleKeyword_1() { return cRoleKeyword_1; }
		
		//name=EString
		public Assignment getNameAssignment_2() { return cNameAssignment_2; }
		
		//EString
		public RuleCall getNameEStringParserRuleCall_2_0() { return cNameEStringParserRuleCall_2_0; }
		
		//'{'
		public Keyword getLeftCurlyBracketKeyword_3() { return cLeftCurlyBracketKeyword_3; }
		
		//('workload' workload=EFloat)?
		public Group getGroup_4() { return cGroup_4; }
		
		//'workload'
		public Keyword getWorkloadKeyword_4_0() { return cWorkloadKeyword_4_0; }
		
		//workload=EFloat
		public Assignment getWorkloadAssignment_4_1() { return cWorkloadAssignment_4_1; }
		
		//EFloat
		public RuleCall getWorkloadEFloatParserRuleCall_4_1_0() { return cWorkloadEFloatParserRuleCall_4_1_0; }
		
		//'}'
		public Keyword getRightCurlyBracketKeyword_5() { return cRightCurlyBracketKeyword_5; }
	}
	public class EFloatElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "tdt4250.ra.RaDSL2022.EFloat");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cHyphenMinusKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final RuleCall cINTTerminalRuleCall_1 = (RuleCall)cGroup.eContents().get(1);
		private final Keyword cFullStopKeyword_2 = (Keyword)cGroup.eContents().get(2);
		private final RuleCall cINTTerminalRuleCall_3 = (RuleCall)cGroup.eContents().get(3);
		private final Group cGroup_4 = (Group)cGroup.eContents().get(4);
		private final Alternatives cAlternatives_4_0 = (Alternatives)cGroup_4.eContents().get(0);
		private final Keyword cEKeyword_4_0_0 = (Keyword)cAlternatives_4_0.eContents().get(0);
		private final Keyword cEKeyword_4_0_1 = (Keyword)cAlternatives_4_0.eContents().get(1);
		private final Keyword cHyphenMinusKeyword_4_1 = (Keyword)cGroup_4.eContents().get(1);
		private final RuleCall cINTTerminalRuleCall_4_2 = (RuleCall)cGroup_4.eContents().get(2);
		
		//EFloat returns ecore::EFloat:
		//    '-'? INT? '.' INT (('E'|'e') '-'? INT)?;
		@Override public ParserRule getRule() { return rule; }
		
		//'-'? INT? '.' INT (('E'|'e') '-'? INT)?
		public Group getGroup() { return cGroup; }
		
		//'-'?
		public Keyword getHyphenMinusKeyword_0() { return cHyphenMinusKeyword_0; }
		
		//INT?
		public RuleCall getINTTerminalRuleCall_1() { return cINTTerminalRuleCall_1; }
		
		//'.'
		public Keyword getFullStopKeyword_2() { return cFullStopKeyword_2; }
		
		//INT
		public RuleCall getINTTerminalRuleCall_3() { return cINTTerminalRuleCall_3; }
		
		//(('E'|'e') '-'? INT)?
		public Group getGroup_4() { return cGroup_4; }
		
		//('E'|'e')
		public Alternatives getAlternatives_4_0() { return cAlternatives_4_0; }
		
		//'E'
		public Keyword getEKeyword_4_0_0() { return cEKeyword_4_0_0; }
		
		//'e'
		public Keyword getEKeyword_4_0_1() { return cEKeyword_4_0_1; }
		
		//'-'?
		public Keyword getHyphenMinusKeyword_4_1() { return cHyphenMinusKeyword_4_1; }
		
		//INT
		public RuleCall getINTTerminalRuleCall_4_2() { return cINTTerminalRuleCall_4_2; }
	}
	
	
	private final DepartmentElements pDepartment;
	private final EStringElements pEString;
	private final PersonElements pPerson;
	private final CourseElements pCourse;
	private final ResourceAllocationElements pResourceAllocation;
	private final RoleElements pRole;
	private final EFloatElements pEFloat;
	
	private final Grammar grammar;
	
	private final TerminalsGrammarAccess gaTerminals;

	@Inject
	public RaDSL2022GrammarAccess(GrammarProvider grammarProvider,
			TerminalsGrammarAccess gaTerminals) {
		this.grammar = internalFindGrammar(grammarProvider);
		this.gaTerminals = gaTerminals;
		this.pDepartment = new DepartmentElements();
		this.pEString = new EStringElements();
		this.pPerson = new PersonElements();
		this.pCourse = new CourseElements();
		this.pResourceAllocation = new ResourceAllocationElements();
		this.pRole = new RoleElements();
		this.pEFloat = new EFloatElements();
	}
	
	protected Grammar internalFindGrammar(GrammarProvider grammarProvider) {
		Grammar grammar = grammarProvider.getGrammar(this);
		while (grammar != null) {
			if ("tdt4250.ra.RaDSL2022".equals(grammar.getName())) {
				return grammar;
			}
			List<Grammar> grammars = grammar.getUsedGrammars();
			if (!grammars.isEmpty()) {
				grammar = grammars.iterator().next();
			} else {
				return null;
			}
		}
		return grammar;
	}
	
	@Override
	public Grammar getGrammar() {
		return grammar;
	}
	
	
	public TerminalsGrammarAccess getTerminalsGrammarAccess() {
		return gaTerminals;
	}

	
	//Department returns Department:
	//    {Department}
	//    'Department'
	//    name=EString
	//    '{'
	//        ('shortName' shortName=EString)?
	//        ('staff' '{' staff+=Person ( "," staff+=Person)* '}' )?
	//        ('courses' '{' courses+=Course ( "," courses+=Course)* '}' )?
	//        ('resourceAllocations' '{' resourceAllocations+=ResourceAllocation ( "," resourceAllocations+=ResourceAllocation)* '}' )?
	//    '}';
	public DepartmentElements getDepartmentAccess() {
		return pDepartment;
	}
	
	public ParserRule getDepartmentRule() {
		return getDepartmentAccess().getRule();
	}
	
	//EString returns ecore::EString:
	//    STRING | ID;
	public EStringElements getEStringAccess() {
		return pEString;
	}
	
	public ParserRule getEStringRule() {
		return getEStringAccess().getRule();
	}
	
	//Person returns Person:
	//    {Person}
	//    'Person'
	//    name=EString
	////    '{'
	////        ('allocations' '(' allocations+=[ResourceAllocation|EString] ( "," allocations+=[ResourceAllocation|EString])* ')' )?
	////    '}'
	//;
	public PersonElements getPersonAccess() {
		return pPerson;
	}
	
	public ParserRule getPersonRule() {
		return getPersonAccess().getRule();
	}
	
	//Course returns Course:
	//    {Course}
	//    'Course'
	//    name=EString
	//    '{'
	//        (
	//            ('code' code=EString)?
	//                &
	//              ('roles' '{' roles+=Role ( "," roles+=Role)* '}' )?
	//        )
	//    '}';
	public CourseElements getCourseAccess() {
		return pCourse;
	}
	
	public ParserRule getCourseRule() {
		return getCourseAccess().getRule();
	}
	
	//ResourceAllocation returns ResourceAllocation:
	//    {ResourceAllocation}
	//    'ResourceAllocation'
	//    '{'
	//        ('factor' factor=EFloat)?
	//        ('person' person=[Person|EString])?
	//        ('course' course=[Course|EString])?
	//        ('role' role=[Role|EString])?
	//    '}';
	public ResourceAllocationElements getResourceAllocationAccess() {
		return pResourceAllocation;
	}
	
	public ParserRule getResourceAllocationRule() {
		return getResourceAllocationAccess().getRule();
	}
	
	//Role returns Role:
	//    {Role}
	//    'Role'
	//    name=EString
	//    '{'
	//        ('workload' workload=EFloat)?
	//    '}';
	public RoleElements getRoleAccess() {
		return pRole;
	}
	
	public ParserRule getRoleRule() {
		return getRoleAccess().getRule();
	}
	
	//EFloat returns ecore::EFloat:
	//    '-'? INT? '.' INT (('E'|'e') '-'? INT)?;
	public EFloatElements getEFloatAccess() {
		return pEFloat;
	}
	
	public ParserRule getEFloatRule() {
		return getEFloatAccess().getRule();
	}
	
	//terminal ID: '^'?('a'..'z'|'A'..'Z'|'_') ('a'..'z'|'A'..'Z'|'_'|'0'..'9')*;
	public TerminalRule getIDRule() {
		return gaTerminals.getIDRule();
	}
	
	//terminal INT returns ecore::EInt: ('0'..'9')+;
	public TerminalRule getINTRule() {
		return gaTerminals.getINTRule();
	}
	
	//terminal STRING:
	//            '"' ( '\\' . /* 'b'|'t'|'n'|'f'|'r'|'u'|'"'|"'"|'\\' */ | !('\\'|'"') )* '"' |
	//            "'" ( '\\' . /* 'b'|'t'|'n'|'f'|'r'|'u'|'"'|"'"|'\\' */ | !('\\'|"'") )* "'"
	//        ;
	public TerminalRule getSTRINGRule() {
		return gaTerminals.getSTRINGRule();
	}
	
	//terminal ML_COMMENT : '/*' -> '*/';
	public TerminalRule getML_COMMENTRule() {
		return gaTerminals.getML_COMMENTRule();
	}
	
	//terminal SL_COMMENT : '//' !('\n'|'\r')* ('\r'? '\n')?;
	public TerminalRule getSL_COMMENTRule() {
		return gaTerminals.getSL_COMMENTRule();
	}
	
	//terminal WS         : (' '|'\t'|'\r'|'\n')+;
	public TerminalRule getWSRule() {
		return gaTerminals.getWSRule();
	}
	
	//terminal ANY_OTHER: .;
	public TerminalRule getANY_OTHERRule() {
		return gaTerminals.getANY_OTHERRule();
	}
}
